package com.org.hktshop.Interface.portal.product;

import com.org.hktshop.entity.Page;
import com.org.hktshop.entity.product.HktGoodItem;
import com.org.hktshop.entity.product.HktGoodsCategory;
import com.org.hktshop.entity.product.HktGoodsSeoDesc;

import java.util.List;
import java.util.Map;

/**
 * @author owen
 */
public interface IPortalProductService {
    /**
     * 商品分类列表
     * @return
     */
    List<HktGoodsCategory> queryList();

    /**
     * 商品详情
     *
     * @param hktGoods
     * @return
     */
    HktGoodItem findProduct(HktGoodItem hktGoods);

    /**
     * 根据条件查找商品列表
     *
     * @param hktGoods
     * @return
     */
    Page<HktGoodItem> selectProductLike(HktGoodItem hktGoods);

    /**
     * 商品搜索提示
     *
     * @param hktGoodsSeoDesc
     * @return
     */
    Page<HktGoodsSeoDesc> selectTitle(HktGoodsSeoDesc hktGoodsSeoDesc);

    /**
     * 统计商品数量
     *
     * @param map
     * @return
     */
    Map<String, Object> statisticsCountProduct(Map map);

    /**
     * 相似商品
     *
     * @param hktGoodItem
     * @return
     */
    Page<Map<String, Object>> resembleProduct(HktGoodItem hktGoodItem);

    /**
     * 其他客户购买得商品
     *
     * @param hktGoodItem
     * @return
     */
    Page<Map<String, Object>> otherProduct(HktGoodItem hktGoodItem);

    /**
     * 商品一级分类
     * @param hktGoodItem
     * @return
     */
    List<Map<String, Object>> prodectCategory(HktGoodItem hktGoodItem);
    /**
     * 猜你喜欢
     * @param hktGoodItem
     * @return
     */
    Page<HktGoodItem> prodectGuesgsYouLike(HktGoodItem hktGoodItem);

    /**
     * 筛选
     * @param hktGoods
     * @return
     */
    Object screen(HktGoodItem hktGoods);

    /**
     * 根据brandId查询商品
     * @param hktGoodItem
     * @return
     */
    List<HktGoodItem> selectProductListByBrandId(HktGoodItem hktGoodItem);

    /**
     * 筛选器
     * @param hktGoodItem
     * @return
     */
    Object filterList(HktGoodItem hktGoodItem);
}
